"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionRenderer = void 0;
const react_1 = __importDefault(require("react"));
const semantics_entities_semantic_schema_1 = require("@teambit/semantics.entities.semantic-schema");
const api_reference_models_api_node_renderer_1 = require("@teambit/api-reference.models.api-node-renderer");
const api_reference_renderers_api_node_details_1 = require("@teambit/api-reference.renderers.api-node-details");
const classnames_1 = __importDefault(require("classnames"));
const api_reference_renderers_parameter_1 = require("@teambit/api-reference.renderers.parameter");
const documenter_ui_table_heading_row_1 = require("@teambit/documenter.ui.table-heading-row");
const function_renderer_module_scss_1 = __importDefault(require("./function.renderer.module.scss"));
exports.functionRenderer = {
    predicate: (node) => node.__schema === semantics_entities_semantic_schema_1.FunctionLikeSchema.name,
    Component: FunctionComponent,
    nodeType: 'Functions',
    icon: { name: 'Function', url: 'https://static.bit.dev/api-reference/function.svg' },
    default: true,
};
function FunctionComponent(props) {
    var _a, _b, _c, _d, _e;
    const { apiNode: { api }, renderers,
    // apiRefModel,
     } = props;
    const functionNode = api;
    const { returnType, params, typeParams } = functionNode;
    const returnTypeRenderer = renderers.find((renderer) => renderer.predicate(returnType));
    if ((_b = (_a = props.metadata) === null || _a === void 0 ? void 0 : _a[api.__schema]) === null || _b === void 0 ? void 0 : _b.columnView) {
        return react_1.default.createElement("div", { className: api_reference_models_api_node_renderer_1.nodeStyles.node }, api.toString());
    }
    const Params = params.map((param) => {
        var _a, _b;
        const paramRenderer = renderers.find((renderer) => renderer.predicate(param));
        const ParamComponent = (paramRenderer === null || paramRenderer === void 0 ? void 0 : paramRenderer.Component) ? (react_1.default.createElement(paramRenderer.Component, Object.assign({}, props, { key: `props-${param.name}`, depth: ((_a = props.depth) !== null && _a !== void 0 ? _a : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: paramRenderer, api: param }), metadata: { [param.__schema]: { columnView: true, skipHeadings: true } } }))) : (react_1.default.createElement(api_reference_renderers_parameter_1.parameterRenderer.Component, Object.assign({}, props, { key: `props-${param.name}`, depth: ((_b = props.depth) !== null && _b !== void 0 ? _b : 0) + 1, apiNode: Object.assign(Object.assign({}, props.apiNode), { renderer: api_reference_renderers_parameter_1.parameterRenderer, api: param }), metadata: { [param.__schema]: { columnView: true, skipHeadings: true } } })));
        return ParamComponent;
    });
    const returnDocComment = (_d = (_c = api.doc) === null || _c === void 0 ? void 0 : _c.findTag(semantics_entities_semantic_schema_1.TagName.return)) === null || _d === void 0 ? void 0 : _d.comment;
    return (react_1.default.createElement(api_reference_renderers_api_node_details_1.APINodeDetails, Object.assign({}, props, { options: { hideIndex: true } }),
        typeParams && (react_1.default.createElement("div", { className: (0, classnames_1.default)(function_renderer_module_scss_1.default.container, function_renderer_module_scss_1.default.typeParams) },
            react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.title }, "Type Parameters"),
            react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.values }, typeParams.map((typeParam) => {
                return (react_1.default.createElement("div", { className: (0, classnames_1.default)(function_renderer_module_scss_1.default.value), key: typeParam }, typeParam));
            })))),
        Params.length > 0 && (react_1.default.createElement("div", { key: `parameter-list`, className: function_renderer_module_scss_1.default.container },
            react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.title }, "Parameters"),
            react_1.default.createElement(documenter_ui_table_heading_row_1.HeadingRow, { className: function_renderer_module_scss_1.default.paramHeading, headings: ['name', 'type', 'default', 'description'], colNumber: 4 }),
            ...Params)),
        react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.container },
            react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.title }, "Returns"),
            returnDocComment && react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.docComment }, returnDocComment),
            react_1.default.createElement("div", { className: function_renderer_module_scss_1.default.returnType }, (returnTypeRenderer && (react_1.default.createElement(returnTypeRenderer.Component, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: returnType, renderer: returnTypeRenderer }), depth: ((_e = props.depth) !== null && _e !== void 0 ? _e : 0) + 1 })))) || react_1.default.createElement("div", { className: api_reference_models_api_node_renderer_1.nodeStyles.node }, returnType.toString())))));
}
//# sourceMappingURL=function.renderer.js.map